# CustomExternalForce Class Reference

This class implements an "external" force on particles. More...

Inheritance diagram for CustomExternalForce:

List of all members.

## Public Member Functions

def | getNumParticles
| getNumParticles(self) -> int
def | getNumPerParticleParameters
| getNumPerParticleParameters(self) -> int
def | getNumGlobalParameters
| getNumGlobalParameters(self) -> int
def | getEnergyFunction
| getEnergyFunction(self) -> string
def | setEnergyFunction
| setEnergyFunction(self, string energy)
def | addPerParticleParameter
| addPerParticleParameter(self, string name) -> int
def | getPerParticleParameterName
| getPerParticleParameterName(self, int index) -> string
def | setPerParticleParameterName
| setPerParticleParameterName(self, int index, string name)
def | addGlobalParameter
| addGlobalParameter(self, string name, double defaultValue) -> int
def | getGlobalParameterName
| getGlobalParameterName(self, int index) -> string
def | setGlobalParameterName
| setGlobalParameterName(self, int index, string name)
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(self, int index) -> double
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(self, int index, double defaultValue)
def | addParticle
| addParticle(self, int particle, vectord parameters) -> int
def | getParticleParameters
| getParticleParameters(self, int index)
def | setParticleParameters
| setParticleParameters(self, int index, int particle, vectord parameters)
def | updateParametersInContext
| updateParametersInContext(self, Context context)
def | __init__
| __init__(self, string energy) -> CustomExternalForce __init__(self, CustomExternalForce other) -> CustomExternalForce
def | __del__
| __del__(self)

## Public Attributes

| this

## Detailed Description

This class implements an "external" force on particles.

The force may be applied to any subset of the particles in the System. The force on each particle is specified by an arbitrary algebraic expression, which may depend on the current position of the particle as well as on arbitrary global and per-particle parameters.

To use this class, create a CustomExternalForce object, passing an algebraic expression to the constructor that defines the potential energy of each affected particle. The expression may depend on the particle's x, y, and z coordinates, as well as on any parameters you choose. Then call addPerParticleParameter() to define per-particle parameters, and addGlobalParameter() to define global parameters. The values of per-particle parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context.setParameter(). Finally, call addParticle() once for each particle that should be affected by the force. After a particle has been added, you can modify its parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomExternalForce that attracts each particle to a target position (x0, y0, z0) via a harmonic potential:

`CustomExternalForce* force = new CustomExternalForce("k*((x-x0)^2+(y-y0)^2+(z-z0)^2)");`

This force depends on four parameters: the spring constant k and equilibrium coordinates x0, y0, and z0. The following code defines these parameters:

``

    force->addGlobalParameter("k", 100.0);
    force->addPerParticleParameter("x0");
    force->addPerParticleParameter("y0");
    force->addPerParticleParameter("z0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Force.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self, string energy) -> CustomExternalForce __init__(self, CustomExternalForce other) -> CustomExternalForce

Create a CustomExternalForce.

Parameters:

  | energy | an algebraic expression giving the potential energy of each particle as a function of its x, y, and z coordinates

def addGlobalParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addGlobalParameter(self, string name, double defaultValue) -> int

Add a new global parameter that the force may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

def addParticle | ( |  | self,
|  |  | args |
| ) |  |  |

addParticle(self, int particle, vectord parameters) -> int

Add a particle term to the force field.

Parameters:

  | particle | the index of the particle this term is applied to
  | parameters | the list of parameters for the new force term

def addPerParticleParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addPerParticleParameter(self, string name) -> int

Add a new per-particle parameter that the force may depend on.

Parameters:

  | name | the name of the parameter

def getEnergyFunction | ( |  | self | ) |

getEnergyFunction(self) -> string

Get the algebraic expression that gives the potential energy of each particle

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterDefaultValue(self, int index) -> double

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

def getGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterName(self, int index) -> string

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getNumGlobalParameters | ( |  | self | ) |

getNumGlobalParameters(self) -> int

Get the number of global parameters that the force depends on.

def getNumParticles | ( |  | self | ) |

getNumParticles(self) -> int

Get the number of particles for which force field parameters have been defined.

def getNumPerParticleParameters | ( |  | self | ) |

getNumPerParticleParameters(self) -> int

Get the number of per-particle parameters that the force depends on

def getParticleParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getParticleParameters(self, int index)

Get the force field parameters for a force field term.

Parameters:

  | index | the index of the particle term for which to get parameters
  | particle | the index of the particle this term is applied to
  | parameters | the list of parameters for the force field term

def getPerParticleParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getPerParticleParameterName(self, int index) -> string

Get the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def setEnergyFunction | ( |  | self,
|  |  | args |
| ) |  |  |

setEnergyFunction(self, string energy)

Set the algebraic expression that gives the potential energy of each particle

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterDefaultValue(self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

def setGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterName(self, int index, string name)

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def setParticleParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setParticleParameters(self, int index, int particle, vectord parameters)

Set the force field parameters for a force field term.

Parameters:

  | index | the index of the particle term for which to set parameters
  | particle | the index of the particle this term is applied to
  | parameters | the list of parameters for the force field term

def setPerParticleParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setPerParticleParameterName(self, int index, string name)

Set the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def updateParametersInContext | ( |  | self,
|  |  | args |
| ) |  |  |

updateParametersInContext(self, Context context)

Update the per-particle parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-particle parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. Also, this method cannot be used to add new particles, only to change the parameters of existing ones.

## Member Data Documentation

this

The documentation for this class was generated from the following file:

- openmm.py